Attribute VB_Name = "modRegistry"
'Reg Key ROOT Types
Global Const HKEY_CLASSES_ROOT = &H80000000
Global Const HKEY_CURRENT_USER = &H80000001
Global Const HKEY_LOCAL_MACHINE = &H80000002
Global Const HKEY_USERS = &H80000003
Global Const HKEY_PERFORMANCE_DATA = &H80000004
Global Const HKEY_CURRENT_CONFIG = &H80000005
Global Const HKEY_DYN_DATA = &H80000006

'Reg Create Type Values
Global Const REG_OPTION_RESERVED = 0 'Parameter is reserved
Global Const REG_OPTION_NON_VOLATILE = 0 'Key is preserved when system is rebooted
Global Const REG_OPTION_VOLATILE = 1 'Key is not preserved when system is rebooted
Global Const REG_OPTION_CREATE_LINK = 2 'Created key is a symbolic link
Global Const REG_OPTION_BACKUP_RESTORE = 4 'open for backup or restore

'Reg Data Types
Global Const REG_NONE = 0 'No value type
Global Const REG_SZ = 1 'Unicode nul terminated string
Global Const REG_EXPAND_SZ = 2 'Unicode nul terminated string
Global Const REG_BINARY = 3 'Free form binary
Global Const REG_DWORD = 4 '32-bit number
Global Const REG_DWORD_LITTLE_ENDIAN = 4 '32-bit number (same as REG_DWORD)
Global Const REG_DWORD_BIG_ENDIAN = 5 '32-bit number
Global Const REG_LINK = 6 'Symbolic Link (unicode)
Global Const REG_MULTI_SZ = 7 'Multiple Unicode strings
Global Const REG_RESOURCE_LIST = 8 'Resource list in the resource map
Global Const REG_FULL_RESOURCE_DESCRIPTOR = 9 'Resource list in the hardware description
Global Const REG_RESOURCE_REQUIREMENTS_LIST = 10
Global Const REG_CREATED_NEW_KEY = &H1 'New Registry Key created
Global Const REG_OPENED_EXISTING_KEY = &H2 'Existing Key opened
Global Const REG_WHOLE_HIVE_VOLATILE = &H1 'Restore whole hive volatile
Global Const REG_REFRESH_HIVE = &H2 'Unwind changes to last flush
Global Const REG_NOTIFY_CHANGE_NAME = &H1 'Create or delete (child)
Global Const REG_NOTIFY_CHANGE_ATTRIBUTES = &H2
Global Const REG_NOTIFY_CHANGE_LAST_SET = &H4 'Time stamp
Global Const REG_NOTIFY_CHANGE_SECURITY = &H8
Global Const REG_LEGAL_CHANGE_FILTER = (REG_NOTIFY_CHANGE_NAME Or REG_NOTIFY_CHANGE_ATTRIBUTES Or REG_NOTIFY_CHANGE_LAST_SET Or REG_NOTIFY_CHANGE_SECURITY)
Global Const REG_LEGAL_OPTION = (REG_OPTION_RESERVED Or REG_OPTION_NON_VOLATILE Or REG_OPTION_VOLATILE Or REG_OPTION_CREATE_LINK Or REG_OPTION_BACKUP_RESTORE)

Global Const SYNCHRONIZE = &H100000

'Reg Key Security Options
Public Const READ_CONTROL = &H20000
Public Const STANDARD_RIGHTS_READ = (READ_CONTROL)
Public Const STANDARD_RIGHTS_WRITE = (READ_CONTROL)
Public Const STANDARD_RIGHTS_ALL = &H1F0000
Public Const KEY_QUERY_VALUE = &H1
Public Const KEY_SET_VALUE = &H2
Public Const KEY_CREATE_SUB_KEY = &H4
Public Const KEY_ENUMERATE_SUB_KEYS = &H8
Public Const KEY_NOTIFY = &H10
Public Const KEY_CREATE_LINK = &H20
Public Const KEY_READ = ((STANDARD_RIGHTS_READ Or KEY_QUERY_VALUE Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY) And (Not SYNCHRONIZE))
Public Const KEY_WRITE = ((STANDARD_RIGHTS_WRITE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY) And (Not SYNCHRONIZE))
Public Const KEY_ALL_ACCESS = ((STANDARD_RIGHTS_ALL Or KEY_QUERY_VALUE Or KEY_SET_VALUE Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY Or KEY_CREATE_LINK) And (Not SYNCHRONIZE))
Public Const KEY_EXECUTE = ((KEY_READ) And (Not SYNCHRONIZE))

Global Const ERROR_NONE = 0
Global Const ERROR_BADDB = 1
Global Const ERROR_BADKEY = 2
Global Const ERROR_CANTOPEN = 3
Global Const ERROR_CANTREAD = 4
Global Const ERROR_CANTWRITE = 5
Global Const ERROR_OUTOFMEMORY = 6
Global Const ERROR_INVALID_PARAMETER = 7
Global Const ERROR_ACCESS_DENIED = 8
Global Const ERROR_INVALID_PARAMETERS = 87
Global Const ERROR_NO_MORE_ITEMS = 259

'Note that if you declare the lpData parameter as String in RegSetValueExA, you must pass it ByVal.
Declare Function RegCloseKey Lib "ADVAPI32.DLL" (ByVal hKey As Long) As Long
Declare Function RegCreateKeyA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpSubKey As String, phkResult As Long) As Long
Declare Function RegOpenKeyExA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Declare Function RegQueryValueExALong Lib "ADVAPI32.DLL" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, lpData As Long, lpcbData As Long) As Long
Declare Function RegQueryValueExANULL Lib "ADVAPI32.DLL" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, lpType As Long, ByVal lpData As Long, lpcbData As Long) As Long
Declare Function RegQueryValueExA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Declare Function RegSetValueExA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpData As Any, ByVal cbData As Long) As Long
Declare Function RegSetValueExAString Lib "ADVAPI32.DLL" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, ByVal lpValue As String, ByVal cbData As Long) As Long
Declare Function RegSetValueExALong Lib "ADVAPI32.DLL" Alias "RegSetValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal Reserved As Long, ByVal dwType As Long, lpValue As Long, ByVal cbData As Long) As Long
Declare Function RegDeleteKeyA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpSubKey As String) As Long
Declare Function RegDeleteValueA Lib "ADVAPI32.DLL" (ByVal hKey As Long, ByVal lpValueName As String) As Long

Function REGDeleteKey(hKey As Long, lpSubKey As String)
REGDeleteKey = RegDeleteKeyA(hKey, lpSubKey)
End Function

Function REGDeleteValue(hKey As Long, lpSubKey As String, lpValueName As String)
r = RegOpenKeyExA(hKey, lpSubKey, 0, KEY_ALL_ACCESS, phkResult)
REGDeleteValue = RegDeleteValueA(phkResult, lpValueName)
r = RegCloseKey(phkResult)
End Function

Function REGGetValue(hKey As Long, lpSubKey As String, lpValueName As String, returnedvaluetype, returnedvaluedata)
r = RegOpenKeyExA(hKey, lpSubKey, 0&, KEY_ALL_ACCESS, phkResult)
r = RegQueryValueExANULL(phkResult, lpValueName, 0&, returnedvaluetype, 0&, returnedvaluelength)
If r = ERROR_NONE Then
 Select Case returnedvaluetype
 Case REG_SZ, REG_BINARY  'string or binary
  returnedSvalue$ = String(32766, 0)
  r = RegQueryValueExA(phkResult, lpValueName, 0&, returnedvaluetype, returnedSvalue$, returnedvaluelength)
  REGGetValue = r
  If r = ERROR_NONE Then returnedvaluedata = Left(returnedSvalue$, returnedvaluelength) Else returnedvaluedata = Empty
 Case REG_DWORD 'dword (number)
  r = RegQueryValueExALong(phkResult, lpValueName, 0&, returnedvaluetype, returnedDvalue, returnedvaluelength)
  REGGetValue = r
  If r = ERROR_NONE Then returnedvaluedata = returnedDvalue Else returnedvaluedata = Empty
 End Select
Else
 REGGetValue = r
 returnedvaluedata = Empty
End If
r = RegCloseKey(phkResult)
End Function

Function GetKeyValueOLD(KeyRoot As Long, KeyName As String, SubKeyRef As String, returnedvalue)
Dim I As Long
Dim hKey As Long
Dim KeyValType As Long
Dim tmpVal As String
Dim KeyValSize As Long

r = RegOpenKeyExA(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey)
If r <> 0 Then GoTo GetKeyError

tmpVal = String$(1024, 0)
KeyValSize = 1024

r = RegQueryValueExA(hKey, SubKeyRef, 0, KeyValType, tmpVal, KeyValSize)
If r <> 0 Then GoTo GetKeyError

If Asc(Mid(tmpVal, KeyValSize, 1)) = 0 Then
 tmpVal = Left(tmpVal, KeyValSize - 1)
Else
 tmpVal = Left(tmpVal, KeyValSize)
End If

returnedvalue = Empty
Select Case KeyValType
Case REG_DWORD
 For v = Len(tmpVal) To 1 Step -1
  returnedvalue = returnedvalue + Format(Hex(Asc(Mid(tmpVal, v, 1))), "00")
 Next
 returnedvalue = Format("&h" & returnedvalue)
Case REG_SZ, REG_BINARY
 returnedvalue = tmpVal
End Select
GetKeyValueOLD = True
r = RegCloseKey(hKey)
Exit Function

GetKeyError:
GetKeyValueOLD = False
r = RegCloseKey(hKey)
End Function

Function REGSetValue(hKey As Long, lpSubKey As String, lpValueName As String, lpData As Variant, dwType As Long)
r = RegOpenKeyExA(hKey, lpSubKey, 0, KEY_ALL_ACCESS, phkResult)
If r <> ERROR_NONE Then Call RegCreateKeyA(hKey, lpSubKey, phkResult)

Select Case dwType
Case REG_SZ, REG_BINARY
 r = RegSetValueExA(phkResult, lpValueName, 0&, dwType, ByVal CStr(lpData & Chr(0)), Len(lpData))
Case REG_DWORD
 r = RegSetValueExA(phkResult, lpValueName, 0&, dwType, CLng(lpData), 4) 'CLng is 4 byte long (#,###,###,###)
End Select
REGSetValue = r
r = RegCloseKey(phkResult)
End Function

Function REGCreateKey(hKey As Long, lpSubKey As String)
REGCreateKey = RegCreateKeyA(hKey, lpSubKey, phkResult)
End Function
